#include <iostream>
#include <vector>
#include <algorithm>
#include "robo.h"
using namespace std;
const int maxn = 210;

vector < int > by_x[2*maxn];
vector < int > by_x_real[maxn];
bool visited_real[maxn][maxn];
char t[maxn][maxn];
pair < int, int > p[] = { {-1, 0}, {0, -1}, {1, 0}, {0, 1} };
char let_p[] = { 'U', 'L', 'D', 'R' };
char opposite[256]; 
int dist_to_second[2*maxn][2*maxn];
int real_dist_to_second[maxn][maxn];
bool visited[2*maxn][2*maxn];

int curr_mandist = 0;

int possible_moving(int i, int dist, int move_robot) {

    int new_dist = output(move_robot, let_p[i]);
    if (new_dist == dist) return -1;
    curr_mandist = new_dist;
    return new_dist;

}

int real_possible_moving(int i, int move_robot) {

    int new_dist = output(move_robot, let_p[i]);
    if (new_dist == curr_mandist) return -1;
    curr_mandist = new_dist;
    return new_dist;

}

int visited_cells, real_cells;

void reset_2() {

    for (int i = 0 ; i < 2*maxn ; ++i)
        fill(visited[i], visited[i]+2*maxn, 0);
    visited_cells = 0;
    for (int i = 0 ; i < 2*maxn ; ++i) {

        by_x[i].clear();

    }

}


void dfs(int x, int y, int move_robot) { // x, y -> position if (r1, c1) was (maxn, maxn)

    ////cout << "dfs: " << x-maxn << ' ' << y-maxn << '\n';

    visited[x][y] = 1;
    ++visited_cells;
    by_x[x].push_back(y);
    dist_to_second[x][y] = curr_mandist;

    for (int i = 0 ; i < 4 ; ++i) {

        auto [dx, dy] = p[i];
        char move_to = let_p[i];
        if (visited[x+dx][y+dy]) continue;
        int new_dist = real_possible_moving(i, move_robot);
        if (new_dist == -1) continue;
        dfs(x + dx, y + dy, move_robot);
        curr_mandist = output(move_robot, opposite[move_to]);

    }

}

void init() {

    opposite[(int)'L'] = 'R';
    opposite[(int)'U'] = 'D';
    opposite[(int)'R'] = 'L';
    opposite[(int)'D'] = 'U';

    ////cout << "init: " << (int)'L' << ' ' << (int)'U' << ' ' << (int)'R' << ' ' << (int)'D' << '\n'; 

}

void reset() {

    for (int i = 0 ; i < maxn ; ++i)
        fill(visited_real[i], visited_real[i]+maxn, 0);

}

pair < int, int > parking_place;
pair < int, int > robot1, robot2;

bool real_dfs(int x, int y, pair < int, int > taken, int move_robot) {

    if (taken != make_pair(x, y) && t[x][y] == 'P') {
        parking_place = make_pair(x, y);
        if (move_robot == 1) robot1 = {x, y};
        else robot2 = {x, y};
        return 1;
    }

    visited_real[x][y] = 1;
    for (int i = 0 ; i < 4 ; ++i) {

        auto [dx, dy] = p[i];
        char move_to = let_p[i];
        if (visited_real[x+dx][y+dy]) continue;
        int new_dist = real_possible_moving(i, move_robot);
        if (new_dist == -1) continue;
        bool res = real_dfs(x + dx, y + dy, taken, move_robot);
        if (res) return 1;
        curr_mandist = output(move_robot, opposite[move_to]);

    }

    return 0;

}

void move_right_up(int move_robot) {
    while (possible_moving(3, curr_mandist, move_robot));
    while (possible_moving(0, curr_mandist, move_robot));
}

void move_left_down(int move_robot) {
    while (possible_moving(2, curr_mandist, move_robot));
    while (possible_moving(1, curr_mandist, move_robot));
} 

void robo(int n, int m, char store[][201], int dist) {

    init();

    for (int i = 0 ; i < n ; ++i)
        for (int j = 0 ; j < m ; ++j)
            t[i+1][j+1] = store[i][j]; 

    int beg_row_real = 1, leftmost_real = maxn;

    ////cout << "by_x_real: \n";

    for (int i = 1 ; i <= n ; ++i) {
        ////cout << i << ": ";
        for (int j = 1 ; j <= m ; ++j) {
            if (t[i][j] == '#') continue;
            by_x_real[i].push_back(j);
            ++real_cells;
            leftmost_real = min(leftmost_real, j);
            ////cout << j << ' ';
        }
        ////cout << '\n';
        if (by_x_real[i].empty()) {
            if (beg_row_real == i) beg_row_real = i+1;
            continue;
        }
    }



    dfs(maxn, maxn, 1);

    int robot_searching = 1;

    if (visited_cells < real_cells-1) {
        cout << "try with 2\n";
        reset_2();
        robot_searching = 2;
        dfs(maxn, maxn, 2);
        if (visited_cells < real_cells-1) {
            cout << "here\n";
            move_right_up(2);
            reset_2();
            robot_searching = 1;
            dfs(maxn, maxn, 1);
            if (visited_cells < real_cells-1) {
                move_right_up(1);
                reset_2();
                dfs(maxn, maxn, 2);
                robot_searching = 2;
            }
        }
    }
    int beg_row = 0, leftmost = maxn*2;
    //cout << "by_x: \n";
    for (int i = 0 ; i < 2*maxn ; ++i) {
        if (by_x[i].empty()) {
            if (beg_row == i) beg_row = i+1;
            continue;
        }
        sort(by_x[i].begin(), by_x[i].end());
        leftmost = min(leftmost, by_x[i][0]);
        //cout << i-maxn << ": ";
        //for (int j : by_x[i]) //cout << j-maxn << ' ';
        //cout << '\n';
    }
    //cerr << "beg row: " << beg_row << ' ' << beg_row_real << '\n';
    for (int i = beg_row, real_i = beg_row_real ; !by_x[i].empty() ; ++i, ++real_i) {
        int first_real_cell = by_x_real[real_i][0];
        int j2 = 0;
        for (int j : by_x[i]) {
            while (j2 < by_x_real[real_i].size() && j - leftmost != by_x_real[real_i][j2] - leftmost_real) ++j2;
            if (j2 == by_x_real[real_i].size()) break;
            //cout << i-maxn << ' ' << real_i << ": " << j-maxn << ' ' << by_x_real[real_i][j2] << ' ' << j2 << '\n';
            real_dist_to_second[real_i][by_x_real[real_i][j2]] = dist_to_second[i][j];
            if (i == maxn && j == maxn) real_dist_to_second[real_i][by_x_real[real_i][j2]] = -1;
            visited_real[real_i][by_x_real[real_i][j2]] = 1;
        }
        
    }
    

    cout << "find robots: " << dist << ' ' << robot_searching << '\n';

    for (int i = 1 ; i <= n ; ++i) {

        for (int j = 1 ; j <= m ; ++j) {

            cout << "i, j: " << i << ' ' << j << " = " << visited_real[i][j] << ' ' << real_dist_to_second[i][j] << '\n';

            if (!visited_real[i][j] && t[i][j] != '#') {
                if (robot_searching == 1) robot2 = {i, j};
                else robot1 = {i, j};
            }
            if (real_dist_to_second[i][j] == -1) {
                if (robot_searching == 1) robot1 = {i, j};   
                else robot2 = {i, j};
            }

        }
    }

    cout << "first robot coords: " << robot1.first << ' ' << robot1.second << '\n';
    cout << "second robot coords: " << robot2.first << ' ' << robot2.second << '\n';

    reset();
    bool res1 = real_dfs(robot1.first, robot1.second, {-1, -1}, 1);
    if (res1) {
        reset();
        //cout << "   first dfs done, begining second: " << robot1.first << ' ' << robot1.second << " \n";
        bool res = real_dfs(robot2.first, robot2.second, {-1, -1}, 2);
        if (!res) {
            reset();
            real_dfs(robot1.first, robot1.second, parking_place, 1);
            reset();
            real_dfs(robot2.first, robot2.second, {-1, -1}, 2);
        }
    } else {
        reset();
        real_dfs(robot2.first, robot2.second, {-1, -1}, 2);
        //cout << "   second dfs done, begining first: " << robot2.first << ' ' << robot2.second << " \n";
        bool res = real_dfs(robot1.first, robot1.second, {-1, -1}, 1);
        if (!res) {
            reset();
            real_dfs(robot2.first, robot2.second, parking_place, 2);
            reset();
            real_dfs(robot1.first, robot1.second, {-1, -1}, 1);
        }
    }

}