#include <bits/stdc++.h>
#include "robo.h"
#define endl '\n'

std::string path[2][201][201];

void bfs(int i, int j, short x, int r, int c, char store[][201]) {
    std::queue<std::pair<int, int> > q;
    path[x][i][j] = "";
    q.push({i, j});
    while (!q.empty()) {
        auto curr = q.front();
        q.pop();
        // down
        if (!(curr.first - 1 == i && curr.second == j) && path[x][curr.first - 1][curr.second] == "" && curr.first - 1 >= 0 && store[curr.first - 1][curr.second] == '.') {
            path[x][curr.first - 1][curr.second] = "D" + path[x][curr.first][curr.second];
            q.push({curr.first - 1, curr.second});
        }
        // up
        if (!(curr.first + 1 == i && curr.second == j) && path[x][curr.first + 1][curr.second] == "" && curr.first + 1 < r && store[curr.first + 1][curr.second] == '.') {
            path[x][curr.first + 1][curr.second] = "U" + path[x][curr.first][curr.second];
            q.push({curr.first + 1, curr.second});
        }
        // left
        if (!(curr.first == i && curr.second - 1 == j) && path[x][curr.first][curr.second - 1] == "" && curr.second - 1 >= 0 && store[curr.first][curr.second - 1] == '.') {
            path[x][curr.first][curr.second - 1] = "R" + path[x][curr.first][curr.second];
            q.push({curr.first, curr.second - 1});
        }
        // right
        if (!(curr.first == i && curr.second + 1 == j) && path[x][curr.first][curr.second + 1] == "" && curr.second + 1 < c && store[curr.first][curr.second + 1] == '.') {
            path[x][curr.first][curr.second + 1] = "L" + path[x][curr.first][curr.second];
            q.push({curr.first, curr.second + 1});
        }
    }
}

void robo(int r, int c, char store[][201], int dist) {
    int parkingDistance = 0;
    int px, py;
    short x = 0;
    for (int i = 0; i < r; ++ i) {
        for (int j = 0; j < c; ++ j) {
            if (store[i][j] == 'P') {
                if (x == 0) {
                    px = i; py = j;
                } else {
                    parkingDistance = std::abs(px - i) + std::abs(py - j);
                }
                bfs(i, j, x ++, r, c, store);
            }
        }
    }
    // try to send R1 to P1
    bool failed = false;
    for (int i = 0; i < r; ++ i) {
        for (int j = 0; j < c; ++ j) {
            failed = false;
            if (path[0][i][j] == "") { continue; }
            for (int c = 0; c < path[0][i][j].size(); ++ c) {
                int dist1 = output(1, path[0][i][j][c]);
                if (dist - dist1 == 0) {
                    failed = true;
                    for (int c1 = c; c1 >= 0; -- c1) {
                        switch(path[0][i][j][c1]) {
                        case 'L':
                            output(1, 'R');
                            break;
                        case 'R':
                            output(1, 'L');
                            break;
                        case 'U':
                            output(1, 'D');
                            break;
                        case 'D':
                            output(1, 'U');
                            break;
                        }
                    }
                    break;
                }
                dist = dist1;
            }
            if (!failed) { break; }
        }
        if (!failed) { break; }
    }
     // try to send R2 to P2
    failed = false;
    for (int i = 0; i < r; ++ i) {
        for (int j = 0; j < c; ++ j) {
            failed = false;
            if (path[1][i][j] == "") { continue; }
            for (int c = 0; c < path[1][i][j].size(); ++ c) {
                int dist1 = output(2, path[1][i][j][c]);
                if (dist - dist1 == 0) {
                    failed = true;
                    for (int c1 = c; c1 >= 0; -- c1) {
                        switch(path[1][i][j][c1]) {
                        case 'L':
                            output(2, 'R');
                            break;
                        case 'R':
                            output(2, 'L');
                            break;
                        case 'U':
                            output(2, 'D');
                            break;
                        case 'D':
                            output(2, 'U');
                            break;
                        }
                    }
                    break;
                }
                dist = dist1;
            }
            if (!failed) { break; }
        }
        if (!failed) { break; }
    }
    if (dist != parkingDistance) {
        // try to send R1 to P2
        bool failed = false;
        for (int i = 0; i < r; ++ i) {
            for (int j = 0; j < c; ++ j) {
                failed = false;
                if (path[1][i][j] == "") { continue; }
                for (int c = 0; c < path[1][i][j].size(); ++ c) {
                    int dist1 = output(1, path[1][i][j][c]);
                    if (dist - dist1 == 0) {
                        failed = true;
                        for (int c1 = c; c1 >= 0; -- c1) {
                            switch(path[1][i][j][c1]) {
                            case 'L':
                                output(1, 'R');
                                break;
                            case 'R':
                                output(1, 'L');
                                break;
                            case 'U':
                                output(1, 'D');
                                break;
                            case 'D':
                                output(1, 'U');
                                break;
                            }
                        }
                        break;
                    }
                    dist = dist1;
                }
                if (!failed) { break; }
            }
            if (!failed) { break; }
        }
         // try to send R2 to P1
        failed = false;
        for (int i = 0; i < r; ++ i) {
            for (int j = 0; j < c; ++ j) {
                failed = false;
                if (path[0][i][j] == "") { continue; }
                for (int c = 0; c < path[0][i][j].size(); ++ c) {
                    int dist1 = output(2, path[0][i][j][c]);
                    if (dist - dist1 == 0) {
                        failed = true;
                        for (int c1 = c; c1 >= 0; -- c1) {
                            switch(path[1][i][j][c1]) {
                            case 'L':
                                output(2, 'R');
                                break;
                            case 'R':
                                output(2, 'L');
                                break;
                            case 'U':
                                output(2, 'D');
                                break;
                            case 'D':
                                output(2, 'U');
                                break;
                            }
                        }
                        break;
                    }
                    dist = dist1;
                }
                if (!failed) { break; }
            }
            if (!failed) { break; }
        }
    }
}
/*
4 5
##P1.
.##..
.....
2...P
*/
