#include<bits/stdc++.h>
#include "robo.h"
using namespace std;

const int maxn = 2048;
int used[maxn][maxn], n, m;

void BFS(int x, int y)
{
    queue < pair <int,int> > q;
    q.push({x,y});
    used[x][y] = 5;
    int i, j;
    while (!q.empty())
    {
        pair <int,int> p = q.front();
        q.pop();
        if (p.first!=0 && !used[p.first-1][p.second])
        {
            used[p.first-1][p.second] = 1;
            q.push({p.first-1 , p.second});
        }
        if (p.first!=n-1 && !used[p.first+1][p.second])
        {
            used[p.first+1][p.second] = 2;
            q.push({p.first+1 , p.second});
        }
        if (p.second!=m-1 && !used[p.first][p.second+1])
        {
            used[p.first][p.second+1] = 3;
            q.push({p.first , p.second+1});
        }
        if (p.second!=0 && !used[p.first][p.second-1])
        {
            used[p.first][p.second-1] = 4;
            q.push({p.first , p.second-1});
        }
    }
}

void robo (int r, int c, char store[201][201], int dist)
{
    n = r;
    m = c;
    int last = dist;
    int k = output(1,'L');
    while (k != last)
    {
        last = k;
        k = output(1,'L');
    }
    int i, j, p1r=-1, p1c, p2r, p2c;
    for (i=0; i<r; ++i)
    {
        for (j=0; j<c; ++j)
        {
            if (j==0 || store[i][j-1]=='#') used[i][j] = 1;
            if (store[i][j] == 'P')
            {
                if (p1r == -1)
                {
                    p1r = i;
                    p1c = j;
                }
                else
                {
                    p2r = i;
                    p2c = j;
                }
            }
        }
    }

    int cnt = 0;
    k = output(1,'D');
    while (k != last)
    {
        last = k;
        k = output(1,'D');
        ++ cnt;
    }
    for (i=0; i<r; ++i)
    {
        for (j=0; j<c; ++j)
        {
            if (i==r-1 || store[i+1][j]=='#')
            {
                if (used[i-cnt][j] == 1) used[i][j] = 2;
            }
        }
    }

    cnt = 0;
    k = output(1,'R');
    while (k != last)
    {
        last = k;
        k = output(1,'R');
        ++ cnt;
    }
    for (i=0; i<r; ++i)
    {
        for (j=0; j<c; ++j)
        {
            if (j==c-1 || store[i][j+1]=='#')
            {
                if (used[i][j-cnt] == 2) used[i][j] = 3;
            }
        }
    }

    cnt = 0;
    k = output(1,'U');
    while (k != last)
    {
        last = k;
        k = output(1,'U');
        ++ cnt;
    }
    int posi, posj;
    bool lamp = true;
    for (i=0; i<r && lamp; ++i)
    {
        for (j=0; j<c && lamp; ++j)
        {
            if (i==0 || store[i-1][j]=='#')
            {
                if (used[i+cnt][j] == 3)
                {
                    posi = i;
                    posj = j;
                    lamp = false;
                }
            }
        }
    }

    memset(used, 0, sizeof(used));
    BFS(p1r, p1c);
    i = posi, j = posj;
    while (used[i][j] != 5)
    {
        if (used[i][j] == 1)
        {
            last = output(1, 'D');
            ++ i;
        }
        else if (used[i][j] == 2)
        {
            last = output(1, 'U');
            --i;
        }
        else if (used[i][j] == 3)
        {
            last = output(1,'L');
            --j;
        }
        else
        {
            last = output(1,'R');
            ++j;
        }
    }

    //***********************************************************************************

    memset(used, 0, sizeof(used));
    k = output(2,'L');
    while (k != last)
    {
        last = k;
        k = output(2,'L');
    }
    for (i=0; i<r; ++i)
    {
        for (j=0; j<c; ++j)
        {
            if (j==0 || store[i][j-1]=='#' || store[i][j-1]=='P') used[i][j] = 1;
        }
    }

    cnt = 0;
    k = output(2,'D');
    while (k != last)
    {
        last = k;
        k = output(2,'D');
        ++ cnt;
    }
    for (i=0; i<r; ++i)
    {
        for (j=0; j<c; ++j)
        {
            if (i==r-1 || store[i+1][j]=='#' || store[i+1][j]=='P')
            {
                if (used[i-cnt][j] == 1) used[i][j] = 2;
            }
        }
    }

    cnt = 0;
    k = output(2,'R');
    while (k != last)
    {
        last = k;
        k = output(2,'R');
        ++ cnt;
    }
    for (i=0; i<r; ++i)
    {
        for (j=0; j<c; ++j)
        {
            if (j==c-1 || store[i][j+1]=='#' || store[i][j+1]=='P')
            {
                if (used[i][j-cnt] == 2) used[i][j] = 3;
            }
        }
    }

    cnt = 0;
    k = output(2,'U');
    while (k != last)
    {
        last = k;
        k = output(1,'U');
        ++ cnt;
    }
    lamp = true;
    for (i=0; i<r && lamp; ++i)
    {
        for (j=0; j<c && lamp; ++j)
        {
            if (i==0 || store[i-1][j]=='#' || store[i-1][j]=='P')
            {
                if (used[i+cnt][j] == 3)
                {
                    posi = i;
                    posj = j;
                    lamp = false;
                }
            }
        }
    }

    memset(used, 0, sizeof(used));
    BFS(p2r, p2c);
    i = posi, j = posj;
    while (used[i][j] != 5)
    {
        if (used[i][j] == 1)
        {
            output(2, 'D');
            ++ i;
        }
        else if (used[i][j] == 2)
        {
            output(2, 'U');
            --i;
        }
        else if (used[i][j] == 3)
        {
            output(2,'L');
            --j;
        }
        else
        {
            output(2,'R');
            ++j;
        }
    }
}